#ifdef __cplusplus
extern "C" {
#endif

// drip general
#include "../src/drip.h"
#include "../src/external.h"
// libmpeg2
#include "../libmpeg2/video_out.h"
#include "../libmpeg2/mpeg2.h"
#include "../libmpeg2/mm_accel.h"
#include "../libvo/video_out_internal.h"
// liba52
#include "../liba52/a52.h"
#include "../liba52/audio_out.h"
#include "../liba52/mm_accel.h"
// other
#include <unistd.h>
#include <string.h>
#include <errno.h>

#ifdef __cplusplus
}
#endif

// defines
//none

// Structs
typedef struct null_frame_s {
    vo_frame_t vo;
    uint8_t * rgb_ptr;
    int rgb_stride;
    int yuv_stride;
} null_frame_t;
typedef struct null_instance_s {
    vo_instance_t vo;
    int prediction_index;
    vo_frame_t * frame_ptr[3];
    null_frame_t frame[3];
    uint8_t * rgbdata;
    int rgbstride;
    int width;
    int bpp;
} null_instance_t;
typedef struct common_instance_s {
    vo_instance_t vo;
    int prediction_index;
    vo_frame_t * frame_ptr[3];
} common_instance_t;

// globals
extern glong SCRstream;
extern common_instance_t *vo_open_instance;

// functions
gint drip_mpeg_open(gchar *input,void handler(guint8*[3]));
gint drip_mpeg_close(void);
gint drip_mpeg_seek_percentage(gfloat perc);
void drip_mpeg_start_demuxing(gint audio_channel);
guchar* drip_mpeg_frame(void);
guchar* drip_mpeg_next_frame(void);
gint drip_mpeg_width(void);
gint drip_mpeg_height(void);
gfloat drip_mpeg_framerate(void);
gint16* fetch_from_audio_buffer(gint chunk_size, gint SCR);
gint drip_audio_samplerate(void);
gint drip_audio_bitrate(void);
gint drip_audio_channels(void);
void output_audio(glong frame);

