
#include "../src/drip.h"
#include <gmodule.h>

#define MAX_FILTERS 256
#define UNSET -9999999

typedef enum module_type_e {SPU,AUDIO,VIDEO,UNKNOWNT} MODULE_TYPE_E;
// SPU   : Subpictures
// AUDIO : Audio channels
// VIDEO : Video frames
typedef enum module_phase_e {PRE,NORMAL,POST,UNKNOWNP} MODULE_PHASE_E;
// When to apply this filter -:-
// -------+-----+-----------------------------+--------------------------------+----------------------------
// PHASE  | SEQ | SPU                         | AUDIO                          | VIDEO                       
// -------+-----+-----------------------------+--------------------------------+----------------------------
// PRE    |  1  | Filter gets raw SPU data    | Filter gets raw undecoded data | Filter gets unzoomed frames 
// NORMAL |  2  | Filter receives spu bitmaps | Filter gets decoded PCM audio  | Filter gets zoomed frames   
// POST   |  3  | >-----------------------------Filters gets data after phase 2----------------------------< 
// -------+-----+-----------------------------+--------------------------------+----------------------------

typedef struct _filter filter;
struct _filter {
    GModule* module;
    GString* module_name;
    gchar* module_filename;
    guint8* (*module_apply_function)(guint8* src, glong size,gulong SCR,gulong PTS);
    GtkWidget* (*module_gui_function)(void);
    gpointer (*module_init_function)(gint,gint,gint,gint,gint,gint,gfloat,guint8*[3],guint8*[3]);
    gpointer (*module_values_function_set)(gfloat,gfloat,gfloat,gfloat,gfloat);
    gpointer (*module_destruct_function)(void);
    MODULE_TYPE_E (*module_type_function)(void);
    MODULE_PHASE_E (*module_phase_function)(void);
    void (*module_values_function_get)(gfloat*);
    gboolean loaded;
    gboolean active;
    enum module_type_e module_type;
    enum module_phase_e module_phase;
    GtkWidget *module_GUI;
};

extern filter filters[MAX_FILTERS]; // list of filters
extern gint filters_index; // index to filters array

#ifdef __cplusplus
extern "C" {
#endif
gboolean load_plugin(gchar* plugin,gchar* directory);
gboolean init_plugins(void);
gboolean close_plugins(void);
#ifdef __cplusplus
}
#endif


