#include <glib.h>
#include <math.h>
#include "scaler.hh"
#include "swscale.hh"
#include "main.hh"

#define FACTOR 1 // = factor of autoclipper -1

/* Globals */
//none


/* Loop 3 planes for zooming */
gboolean scaler_apply(gint sw,gint sh,gint dw,gint dh, guint8 *src[3], guchar *dest) {
    guint8 *destptr[3] = {dest,dest+(dw*dh),dest+(dw*dh)*5/4};
    gint stride[3] = {(sw+FACTOR)&(~FACTOR),((sw+FACTOR)&(~FACTOR))/2,((sw+FACTOR)&(~FACTOR))/2};
    
    //g_log(DRIP_LD,G_LOG_LEVEL_DEBUG,"Scaling (sw=%i,sh=%i,dw=%i,dh=%i)",sw,sh,dw,dh);
    /* Call MPlayer's software scaler */
    SwScale_YV12slice(src,stride, 0, sh, destptr, dw, 12, sw, sh, dw, dh);

    return TRUE;
}


/* Initialize scalar, calculate lookup tables */
gboolean scaler_init(gint sw,gint sh,gint dw,gint dh) {
    //double zoomx = ((double)dw)/(double)sw;
    //double zoomy = ((double)dh)/(double)sh;
    //double xr, yr;
    //gint i, p, x, y,color;
    //gfloat i_float;

    /* Checks */
    if (dw>1023 || dh>1023) {
        g_log(DRIP_LD,G_LOG_LEVEL_ERROR,"Destination size >1023");
    }

    /* Calc tables */
    g_log(DRIP_LD,G_LOG_LEVEL_DEBUG,"Calculating scaling tables (sw=%i,sh=%i,dw=%i,dh=%i)",sw,sh,dw,dh);
    SwScale_Init(); // MPlayer software scale init

    /* Clean & Exit */
    g_log(DRIP_LD,G_LOG_LEVEL_DEBUG,"Scaling filter initialized");
    return TRUE;
}


