/*
 * Copyright (C) 2000  Thomas Mirlacher
 * Patched to I420 colourspace (12bits) and reverse vertical by Jarl van Katwijk
 * 
 *
 */


#include <sys/types.h>
#include <glib.h>
#include "spu.h"

static gint aligned;
static guint16 field = 0;
static guint8 *byte_pos;

// Proto's
void overlay(guint8 *background[3],gint xb,gint yb,gint ob,struct spu_img_struct *spu,gfloat o1);



/* Mixing function for YV12 mode */
static inline void display_mix_function_yuv(guint32 color, guint32 contrast, guint8 *y_pixel, gint field, guint8 *u_pixel, guint8 *v_pixel) {
    register gint n;
    register guint32 invcontrast = 256 - contrast;
    register guint8 y, u, v;
    register guint32 py;
    static gint odd;
    static guint32 pu, pv;

    /* if total transparency do nothing */
    if(contrast != 0) {
        u = (color >> 16) & 0xff;
        v = (color >> 8) & 0xff;
        y = color & 0xff;

        /* if no transparancy just overwrite */
        if(contrast == (0xf<<4)) {
            y_pixel[0] = y;
            /* only write uv on even columns and rows */
            if(!field) {
                gint odd = (gint)y_pixel & 1;
                for(n = odd; n < (2 - odd)>>1; n++) {
                    u_pixel[n] = u;
                    v_pixel[n] = v;
                }
            } 
        } else {
            py = y_pixel[0];
            py = (py * invcontrast + y * contrast) >> 8;
            y_pixel[0] = py;
            /* only write uv on even columns and rows */
            if(!field) {
                odd = (gint)y_pixel & 1;
                for(n = odd; n < (2 - odd)>>1; n++) {
                    pu = u_pixel[n];
                    pu = (pu * invcontrast + u * contrast) >> 8;
                    u_pixel[n] = pu;
                    pv = v_pixel[n];
                    pv = (pv * invcontrast + v * contrast) >> 8;
                    v_pixel[n] = pv;
                }
            }
        }  
    }
}

static inline void set_byte (guint8 *byte) {
    byte_pos = byte;
    aligned = 1;
}


void overlay(guint8 *background[3],gint xb,gint yb,gint ob,struct spu_img_struct *spu,gfloat o1) {
    static guint x;
    static guint y;
    static guint32 colour;
    static guint32 contrast;
    static guchar *spu_data_ptr;
    static guint line_y,offset;
    static gchar *addr;
    static gchar *addr_u, *addr_v;

    #ifdef DEBUG
    g_log(SPU_LD,G_LOG_LEVEL_DEBUG,"SPU: Overlaying x=%i, y=%i,  spu->x=%i, spu->y=%i",xb,yb,spu->x,spu->y);
    #endif
    spu_data_ptr = (guchar *) spu->data;
    for (y=0;y<spu->height; y++) {
        for (x=0;x<spu->width; x++) {
            /* Define colour and contrast */
            colour = (*spu_data_ptr)&0xF;
            contrast = (*spu_data_ptr)&0xF0;;
            /* Overlay if not completely transparant */
            if(contrast != 0) {
                line_y = (y + spu->y) * xb;
                offset = line_y + x + spu->x;
                addr = background[0];
                addr = addr + offset;
                addr_u = background[1];
                addr_v = background[2];
                display_mix_function_yuv(spu_clut[colour], contrast, addr, field, addr_u, addr_v);
            }
            spu_data_ptr++;
        }
        field = 1-field;  /* even\odd fields */
    }
    return;
}

