#include "../config.h"
#include <gnome.h>
#include "callbacks.h"
#include "process.h"
#include "interface.h"
#include "support.h"
#include "drip.h"
#include <pthread.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <unistd.h>
#include <sys/types.h>
#include <fcntl.h>
#include <dvddb.h>
#include <sys/ioctl.h>
#include <inttypes.h>
#include <ctype.h>
#include <errno.h>
#include <assert.h>
#include <gdk/gdkx.h>
#include "../encoder/external.hh"
#include "../encoder/plugin-loader.hh"

/* GLOBALS */
GtkWidget *propertybox1 = NULL;
GtkWidget *select_dialog;
GtkWidget *spinbutton1;
GtkWidget *spinbutton2;
GtkWidget *spinbutton3;
GtkWidget *spinbutton4;
GtkWidget *spinbutton5;
GtkWidget *entry3;
GtkWidget *stop_dialog = NULL;
GtkWidget *audio_subpicture_dialog;
GtkWidget *druid_vbox3;
GtkWidget *druid_vbox2;
GtkWidget *window1;
GtkWidget *hbox21;
GtkWidget *hbox22;
GtkWidget *vbox9b;
GtkWidget *frame1;
GtkWidget *frame5;

void on_button_main_rip_clicked(GtkButton *button, gpointer user_data) {
    pthread_t ripthread;
    gint ripthread_id;
    if (converting == FALSE) {
        /* start conversion thread */
        if (Config.useDVDdevice == TRUE ) Config.conversion_mode = DVDTITLE_DVDDISK; /* automatic dvd stream select */
        if (Config.useDVDdevice == FALSE) Config.conversion_mode = DVDTITLE_DRIPCACHE;
        converting = TRUE;
        paused = FALSE;
        ripthread_id = pthread_create(&ripthread,NULL,conversion_thread,NULL);
        #ifdef LM_SENSORS
        /* heat monitoring */
        if (heatthread_id!=0) pthread_cancel(heatthread);
        heatthread_id = pthread_create(&heatthread,NULL,heat_thread,NULL);
        #endif /* LM_SENSORS */
    } else {
        GtkWidget* buzy;
        buzy = create_messagebox_buzy();
        gtk_widget_show(buzy);
    }
    return;
}


void on_button_main_rescan_clicked(GtkButton *button,gpointer user_data) {
    if (converting == FALSE) {
        /* start conversion thread */
        Config.conversion_mode = MPEG_PLAIN; /* manual dvd stream select */
        converting = TRUE;
        ripthread_id = pthread_create(&ripthread,NULL,conversion_thread,NULL);
        #ifdef LM_SENSORS
        /* heat monitoring */
        if (heatthread_id!=0) pthread_cancel(heatthread);
        heatthread_id = pthread_create(&heatthread,NULL,heat_thread,NULL);
        #endif /* LM_SENSORS */
    } else {
        GtkWidget* buzy;
        buzy = create_messagebox_buzy();
        gtk_widget_show(buzy);
    }
}

void on_button_eject_clicked(GtkButton *button, gpointer user_data) {
    GString *command = g_string_new("");
    GString *command2 = g_string_new("");

    if (Config.track_dir == NULL || Config.track_dir->len == 0) {
        g_string_sprintf(command,"%s",detect_source_track_dir(FALSE));
    } else {
        g_string_sprintf(command,"%s",Config.track_dir->str);
    }
    if (Config.DVDhandle!=NULL) { 
        DVDClose(Config.DVDhandle);
        Config.DVDhandle = NULL;
    }
    if (command!=NULL && command->len>0) {
        eject_dvdrom(Config.track_dir->str,Config.DVDdevice->str,FALSE);
    } else {
        g_string_sprintf(command,"Unable to eject, DVD device %s not valid?",Config.DVDdevice->str);
        drip_error(command->str);
    }
    /* Clean & Exit */
    g_string_free(command,TRUE);
    g_string_free(command2,TRUE);
    return;
}


void on_button_main_pref_clicked(GtkButton *button, gpointer user_data) {
    return;
}


void on_homepage_activate (GtkButton *button, gpointer user_data) {
    gint result;
    printf("About to show url..");
    drip_system("gnome-moz-remote --newwin http://drip.sourceforge.net",&result,TRUE,FALSE);
    printf("done\n");
    return;
}


void on_button_main_exit_clicked(GtkButton *button, gpointer user_data) {
    terminate(FALSE,FALSE);
    return;
}


void on_propertybox1_destroy(GtkObject *object,gpointer user_data) {
    save_config(FALSE);
    propertybox1 = NULL;
    return;
}


gboolean on_mainwindow_destroy_event(GtkWidget *widget,GdkEvent *event,gpointer user_data) {
    if (converting == FALSE) {
        terminate(TRUE,FALSE);
    } else {
        GtkWidget* buzy;
        buzy = create_messagebox_buzy();
        gtk_widget_show(buzy);
    }
    return FALSE;
}

gboolean on_mainwindow_delete_event(GtkWidget *widget,GdkEvent *event, gpointer user_data) {
    if (converting == FALSE) {
        terminate(TRUE,FALSE);
    } else {
        GtkWidget* buzy;
        buzy = create_messagebox_buzy();
        gtk_widget_show(buzy);
    }
    return FALSE;
}

void on_combo_entry_dvddevice_changed(GtkEditable *editable, gpointer user_data) {
    GtkWidget *combo = (GtkWidget*)user_data;
    GString *command = g_string_new("");
    /* Set Config DVDdevice string to user input */
    g_string_sprintf(Config.DVDdevice,"%s",gtk_entry_get_text(GTK_ENTRY(combo)));
    /* Clean & Exit */
    g_string_free(command,TRUE);
    return;
}

void on_combo_entry_plugin_changed(GtkEditable *editable, gpointer user_data) {
    GtkWidget *combo = (GtkWidget*)user_data;
    static GtkWidget *plugin_GUI = NULL;
    GString *command = g_string_new("");
    gint i;
    /* Destroy old plug */
    if (plugin_GUI != NULL) {
        gtk_widget_destroy(plugin_GUI);
    }
    /* Build new plugin gui */
    g_string_sprintf(command,"%s",gtk_entry_get_text(GTK_ENTRY(combo)));
    for (i=0;i<filters_index;i++) {
        if (strcmp(filters[i].module_name->str,command->str)==0) {
            plugin_GUI = (*filters[i].module_gui_function)();
            //if (filters[i].module_GUI!=NULL) gtk_widget_destroy(filters[i].module_GUI);
            filters[i].module_GUI = gtk_plug_new(GDK_WINDOW_XWINDOW(plugin_GUI_socket->window));
            gtk_widget_show(GTK_WIDGET(filters[i].module_GUI));
            gtk_container_add (GTK_CONTAINER(filters[i].module_GUI), plugin_GUI);
            gtk_widget_show(plugin_GUI);
            gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton_active), filters[i].active);
            i = filters_index;
        }
    }
    /* Clean & Exit */
    g_string_free(command,TRUE);
    return;
}   

void on_combo_entry_dvdsource_changed(GtkEditable *editable,gpointer user_data) {
    gchar *last_char;
    GtkWidget *combo = (GtkWidget*)user_data;
    g_string_sprintf(Config.DVDsource,"%s",g_strstrip(gtk_entry_get_text(GTK_ENTRY(combo))));
    /* force "/" at end */
    last_char = (gchar*)((glong)Config.DVDsource->str + Config.DVDsource->len - 1);
    if (strncmp(last_char,"/",1)) {
        Config.DVDsource = g_string_append(Config.DVDsource,"/");
    }
    return;
}


void on_combo_entry2_changed(GtkEditable *editable,gpointer user_data) {
    GtkWidget *combo = (GtkWidget*)user_data;
    g_string_sprintf(Config.DIVXfileUser,"%s",gtk_entry_get_text(GTK_ENTRY(combo)));
    return;
}

void on_spinbutton_blur_changed(GtkEditable *editable,gpointer user_data) {
    GtkWidget *entry = (GtkWidget*)user_data;
    Config.blurradius = atoi(gtk_entry_get_text(GTK_ENTRY(entry)));
    return;
}

void on_spinbutton_cpus_changed(GtkEditable *editable,gpointer user_data) {
    GtkWidget *entry = (GtkWidget*)user_data;
    Config.cpus = atoi(gtk_entry_get_text(GTK_ENTRY(entry)));
    return;
}


void on_spinbutton_video_bitrate_changed(GtkEditable *editable,gpointer user_data) {
    GtkWidget *entry = (GtkWidget*)user_data;
    Config.video_bitrate = atoi(gtk_entry_get_text(GTK_ENTRY(entry)));
    return;
}

void on_spinbutton_video_stream_changed(GtkEditable *editable, gpointer user_data) {
    GtkWidget *entry = (GtkWidget*)user_data;
    Config.video_stream = atoi(gtk_entry_get_text(GTK_ENTRY(entry)));
    return;
}


void on_combo_audio_bitrate_changed(GtkEditable *editable, gpointer user_data) {
    GtkWidget *entry = (GtkWidget*)user_data;
    if (strcmp(gtk_entry_get_text(GTK_ENTRY(entry)),"auto")==0) {
        Config.audio_bitrate = -1;
    } else {
        Config.audio_bitrate = atoi(gtk_entry_get_text(GTK_ENTRY(entry)));
    }
    return;
}


void on_spinbutton_audio_stream_changed(GtkEditable *editable, gpointer user_data) {
    GtkWidget *entry = (GtkWidget*)user_data;
    Config.audio_stream = atoi(gtk_entry_get_text(GTK_ENTRY(entry)));
    return;
}

void on_spinbutton_clip_changed(GtkEditable *editable, gpointer user_data) {
    Config.cliptop = atoi(gtk_editable_get_chars(editable,0,-1));
    return;
}

void on_spinbutton_clipleft_changed(GtkEditable *editable, gpointer user_data) {
    Config.clipleft = atoi(gtk_editable_get_chars(editable,0,-1));
    return;
}

void on_spinbutton_clipright_changed(GtkEditable *editable, gpointer user_data) {
    Config.clipright = atoi(gtk_editable_get_chars(editable,0,-1));
    return;
}

void on_spinbutton_clip_offset_changed(GtkEditable *editable, gpointer user_data) {
    Config.clipbottom = atoi(gtk_editable_get_chars(editable,0,-1));
    return;
}


void on_checkbutton_limit_toggled(GtkToggleButton *togglebutton, gpointer user_data) {
    return;
}


void on_checkbutton_eject_toggled(GtkToggleButton *togglebutton, gpointer user_data) {
    Config.eject_dvdrom = gtk_toggle_button_get_active(togglebutton);
    return;
}

void on_checkbutton_active_toggled(GtkToggleButton *togglebutton, gpointer user_data) {
    GString *command = g_string_new("");
    GtkWidget *combo = (GtkWidget*)user_data;
    gint i;
    /* Build new plugin gui */
    g_string_sprintf(command,"%s",gtk_entry_get_text(GTK_ENTRY(combo)));
    for (i=0;i<filters_index;i++) {
        if (strcmp(filters[i].module_name->str,command->str)==0) {
            filters[i].active = gtk_toggle_button_get_active(togglebutton);
            i = filters_index;
        }
    }
    /* Clean & Exit */
    g_string_free(command,TRUE);
    return;
}

void on_checkbutton_hyperzoom_toggled(GtkToggleButton *togglebutton, gpointer user_data) {
    Config.hyper_zoom = gtk_toggle_button_get_active(togglebutton);
    return;
}

void on_checkbutton_autoclip_toggled(GtkToggleButton *togglebutton, gpointer user_data) {
    Config.autoclip = gtk_toggle_button_get_active(togglebutton);
    return;
}

void on_checkbutton_deinterlace_toggled(GtkToggleButton *togglebutton, gpointer user_data) {
    Config.deinterlace = gtk_toggle_button_get_active(togglebutton);
    return;
}

void on_checkbutton_pulldown_toggled(GtkToggleButton *togglebutton, gpointer user_data) {
    Config.pulldown = gtk_toggle_button_get_active(togglebutton);
    return;
}

void on_checkbutton_dvddb_toggled(GtkToggleButton *togglebutton, gpointer user_data) {
    Config.use_dvddb = gtk_toggle_button_get_active(togglebutton);
    return;
}


void on_checkbutton_debug_toggled(GtkToggleButton *togglebutton, gpointer user_data) {
    Config.debug_log = gtk_toggle_button_get_active(togglebutton);
    return;
}


void on_entry2_changed(GtkEditable *editable, gpointer user_data) {
    GtkWidget *entry = (GtkWidget*)user_data;
    Config.nice = atoi(gtk_entry_get_text(GTK_ENTRY(entry)));
    return;
}

void on_checkbutton_audionorm_toggled(GtkToggleButton *togglebutton, gpointer user_data) {
    Config.audio_norm = gtk_toggle_button_get_active(togglebutton);
    return;
}

void on_spinbutton_width_changed(GtkEditable *editable, gpointer user_data) {
    GtkWidget *entry = (GtkWidget*)user_data;
    Config.width = atoi(gtk_entry_get_text(GTK_ENTRY(entry)));
}

void on_spinbutton_heigth_changed(GtkEditable *editable, gpointer user_data) {
    GtkWidget *entry = (GtkWidget*)user_data;
    Config.height = atoi(gtk_entry_get_text(GTK_ENTRY(entry)));
}

void on_dvdstreams_select_row(GtkCList *clist,gint row,gint column,GdkEvent *event,gpointer user_data) {
    GdkColor col_yes,col_no;
    gchar *text;
    gint result;

    /* Allocate colours */
    gdk_color_parse("white",&col_no);
    gdk_color_parse("green3",&col_yes);

    /* Anything at all? */
    result = gtk_clist_get_text(clist,row,3,(gchar**)&text);
    if (result!=1) 
        return;

    if (strstr(text,"NO")!=NULL) {
        gtk_clist_set_text(clist,row,3,"   YES   ");
        gtk_clist_set_background(GTK_CLIST(clist),row,&col_yes);
    } 

    if (strstr(text,"YES")!=NULL) {
        gtk_clist_set_text(clist,row,3,"   NO   ");
        gtk_clist_set_background(GTK_CLIST(clist),row,&col_no);
    }

    return;
}


void on_dvdtitels_select_row(GtkCList *clist,gint row,gint column,GdkEvent *event,gpointer user_data) {
    /* Select titel */
    Config.CS[row] = TRUE;
    /* Build audio\subpictures page */
    on_combo_entry_DVDtitle_changed(NULL,NULL);
    return;
}


void on_dvdtitels_unselect_row(GtkCList *clist,gint row,gint column,GdkEvent *event,gpointer user_data) {
    /* Unselect titel */
    Config.CS[row] = FALSE;
    /* Build audio\subpictures page */
    on_combo_entry_DVDtitle_changed(NULL,NULL);
    return;
}


/* Parse selected mpeg input streams */
void on_dvdstream_ok_clicked(GtkButton *button,gpointer user_data) {
    gint row = 0;
    gint file = 0;
    gchar *text;
    /* Anything selected at all? */
    if (gtk_clist_get_text(GTK_CLIST(user_data),row,3,(gchar**)&text) == 1) {
        do {
            gtk_clist_get_text(GTK_CLIST(user_data),row,3,(gchar**)&text);
            if (strstr(text,"YES") != NULL) {
                /* this file should be encoded */
                gtk_clist_get_text(GTK_CLIST(user_data),row,0,(gchar**)&text);
                files[file] = g_string_new(Config.DVDsource->str);
                files[file] = g_string_append(files[file],"/");
                files[file] = g_string_append(files[file],text);
                file++;
                g_print("%s should be encoded\n",files[file-1]->str);
            }
            row++;
        }
        while (gtk_clist_get_text(GTK_CLIST(user_data),row,3,(gchar**)&text) == 1);
    }
    /* --- */
    selected_files = file;
    gtk_widget_destroy(select_dialog);
    return;
}

void on_dvdstream_cancel_clicked(GtkButton *button,gpointer user_data) {
    selected_files = 0;
    gtk_widget_destroy(select_dialog);
    return;
}

void on_button8_clicked(GtkButton *button,gpointer user_data) {
    /* calculate bitrate */
    gint size = atoi(gtk_entry_get_text(GTK_ENTRY(spinbutton1)));
    gint duration = atoi(gtk_entry_get_text(GTK_ENTRY(spinbutton2)));
    gint audio = atoi(gtk_entry_get_text(GTK_ENTRY(spinbutton3)));
    gint width = atoi(gtk_entry_get_text(GTK_ENTRY(spinbutton4)));
    gint height = atoi(gtk_entry_get_text(GTK_ENTRY(spinbutton5)));
    gfloat res = width * height * 0.000000006607788;
    gfloat bitrate = (((size/1024/1024)-(duration*audio*0.013721987)-(duration*res))/res)/(duration*5.5); /* for pal 25fps */
    GString *format = g_string_new("");

    /* Correct for other than PAL */
    if (CALCframerate != 25 ) {
        bitrate = bitrate/CALCframerate*25.00;
    }

    
    g_string_sprintf(format,"%i",(gint)bitrate);
    gtk_entry_set_text(GTK_ENTRY(entry3),format->str);

    g_string_free(format,TRUE);
    return;
}


void on_button10_clicked(GtkButton *button, gpointer user_data) {
    /* close calc window */
    gtk_widget_destroy(GTK_WIDGET(user_data));
    return;
}

void on_checkbutton_encode_toggled(GtkToggleButton *togglebutton, gpointer user_data) {
    Config.encode = gtk_toggle_button_get_active(togglebutton);
    return;
}

void on_checkbutton_iso_toggled(GtkToggleButton *togglebutton, gpointer user_data) {
    Config.create_iso = gtk_toggle_button_get_active(togglebutton);
    return;
}

void on_spinbutton_maxsizeoutput_changed(GtkEditable *editable, gpointer user_data) {
    GtkWidget *entry = (GtkWidget*)user_data;
    Config.maxsize = atol(gtk_entry_get_text(GTK_ENTRY(entry)));
    return;
}

void on_stop_activate(GtkMenuItem *menuitem, gpointer user_data) {
    if (converting) {
        stop_dialog = create_stop_dialog();
        gtk_widget_show(stop_dialog);
    }
    /* TODO : if (cacheing) { */
    return;
}

void on_pause_activate(GtkMenuItem *menuitem, gpointer user_data) {
    if (converting) {
        if (paused==FALSE) {
            encoder_pause(FALSE);
            paused = TRUE;
            gnome_appbar_set_status(GNOME_APPBAR(appbar1),"PAUSED, click Pause again to resume");

        } else {
            encoder_resume(FALSE);
            paused = FALSE;
            gnome_appbar_set_status(GNOME_APPBAR(appbar1),"Resuming...");
        }
    }
    return;
}

void on_radiobutton_useDVDdevice_toggled(GtkToggleButton *togglebutton, gpointer user_data) {
    Config.useDVDdevice = (gtk_toggle_button_get_active(togglebutton));
    return;
}

void on_radiobutton_PAL_toggled(GtkToggleButton *togglebutton, gpointer user_data) {
    if (gtk_toggle_button_get_active(togglebutton) == TRUE) {
        CALCframerate = 25.00;
    }
    return;
}

void on_radiobutton_NTSC_toggled(GtkToggleButton *togglebutton, gpointer user_data) {
    if (gtk_toggle_button_get_active(togglebutton) == TRUE) {
        CALCframerate = 29.97;
    }
    return;
}


void on_radiobutton_useDVDsource_toggled (GtkToggleButton *togglebutton,gpointer user_data) {
    Config.useDVDdevice = !(gtk_toggle_button_get_active(togglebutton));
    return;
}


/* User clicked OK on 'Really quit encoding proces
   Here all flags are set to reach idle mode */
void on_button_ok_stop_clicked(GtkButton *button, gpointer user_data) {
    if (stop_dialog) {
        if (paused==TRUE) {
            encoder_resume(FALSE);       // resume encoder
        }
        encoder_stop(FALSE);             // stop encoder

        converting = FALSE;              // clear encoding flag
        encoding_time = FALSE;           // ---
        quit_converting = TRUE;          // set request quit flag, used to shutdown threads by request
        stopped = TRUE;                  // set general idle mode flag
        paused = FALSE;                  // lift pause block

        gtk_widget_destroy(stop_dialog); // Remove dialog
        gnome_appbar_set_status(GNOME_APPBAR(appbar1),"");
        gnome_appbar_set_progress(GNOME_APPBAR(appbar1),1);

        pthread_cancel(ripthread);       // cancel encoding thread

        g_log(DRIP_CB_LD,G_LOG_LEVEL_INFO,"Encoding stopped.");
    }
    return;
}


void on_button_no_stop_clicked(GtkButton *button,gpointer user_data) {
    if (stop_dialog) {
        gtk_widget_destroy(stop_dialog);
    }
    return;
}


void on_combo_entry_cache_location_changed(GtkEditable *editable, gpointer user_data) {
    gchar *last_char = NULL;
    GtkWidget *combo = (GtkWidget*)user_data;
    g_string_sprintf(Config.CACHElocation,"%s",gtk_entry_get_text(GTK_ENTRY(combo)));
    /* force "/" at end */
    last_char = (gchar*)((glong)Config.CACHElocation->str + Config.CACHElocation->len - 1);
    if (strncmp(last_char,"/",1)) {
        Config.CACHElocation = g_string_append(Config.CACHElocation,"/");
    }
    return;
}


void on_checkbutton_delete_cache_toggled (GtkToggleButton *togglebutton, gpointer user_data) {
    Config.cache_delete_on_exit = (gtk_toggle_button_get_active(togglebutton));
    return;
}


void on_button11_clicked(GtkButton *button, gpointer user_data) {
    /* OK on audio\subpicture dialog */
    gtk_widget_destroy(audio_subpicture_dialog);
    audio_subpicture_dialog = NULL;
    return;
}


void on_button13_clicked(GtkButton *button,gpointer user_data) {
    /* Cancel on audio\subpicture dialog */
    converting = FALSE;
    pthread_cancel(ripthread);
    gtk_widget_destroy(audio_subpicture_dialog);
    gnome_appbar_set_status(GNOME_APPBAR(appbar1),"Ready.");
    return;
}

void on_radiobutton_audio_channel_0_toggled (GtkToggleButton *togglebutton, gpointer user_data) {
    Config.audio_stream = 0;
    return;
}


void on_radiobutton_audio_channel_1_toggled(GtkToggleButton *togglebutton,gpointer user_data) {
    Config.audio_stream = 1;
    return;
}


void on_radiobutton_audio_channel_2_toggled (GtkToggleButton *togglebutton, gpointer user_data) {
    Config.audio_stream = 2;
    return;
}


void on_radiobutton_audio_channel_3_toggled (GtkToggleButton *togglebutton, gpointer user_data) {
    Config.audio_stream = 3;
    return;
}


void on_radiobutton_audio_channel_4_toggled (GtkToggleButton *togglebutton, gpointer user_data) {
    Config.audio_stream = 4;
    return;
}


void on_radiobutton_audio_channel_5_toggled (GtkToggleButton *togglebutton, gpointer user_data) {
    Config.audio_stream = 5;
    return;
}


void on_radiobutton_audio_channel_6_toggled (GtkToggleButton *togglebutton, gpointer user_data) {
    Config.audio_stream = 6;
    return;
}

void on_radiobutton_audio_channel_7_toggled (GtkToggleButton *togglebutton,gpointer user_data) {
    Config.audio_stream = 7;
    return;
}


void on_combo_entry9_changed(GtkEditable *editable, gpointer user_data) {
    gint i = 0;
    GtkWidget *combo = (GtkWidget*)user_data;
    gint CS = first_selected_titel();
 
    while (i<32 && strcmp(gtk_entry_get_text(GTK_ENTRY(combo)),Config.subpicture_names[Config.VT_belongs_to_VTS[Config.CS_belongs_to_VT[CS]]][i]->str)) {
        i++;
    }
    if (i<32) { /* 33 = ( 32subpictures + 1none) -1 */
        /* Found subpicture stream */
        Config.subpicture_stream = i;
    } else {
        /* None or ?unknown? -> set to None (=-1) */
        Config.subpicture_stream = -1; 
    }
 
    return;
}

/* Update selected video codec */
void on_combo_entry11_changed(GtkEditable *editable, gpointer user_data) {
    gint i = 0;
    GtkWidget *combo = (GtkWidget*)user_data;
    while (i<Config.codecs_amount && strcmp(gtk_entry_get_text(GTK_ENTRY(combo)),Config.codecs[i].cdescription->str)) {
        i++;
    }
    Config.encoding_video_codec = i;

    return;
}

/* Update selected audio codec */
void on_combo_audiocodec_changed(GtkEditable *editable, gpointer user_data) {
    gint i = 0;
    GtkWidget *combo = (GtkWidget*)user_data;
    while (i<Config.codecs_amount && strcmp(gtk_entry_get_text(GTK_ENTRY(combo)),Config.codecs[i].cdescription->str)) {
        i++;
    }
    Config.encoding_audio_codec = i;

    return;
}


/* Change title to user selection for Druid dialog */
void on_combo_entry_DVDtitle_changed(GtkEditable *editable,gpointer user_data) {
  GtkWidget *label_ripdvd_select_audio_channel;
  GtkWidget *vbox9;
  GSList *audio_channels_group = NULL;
  GtkWidget *radiobutton_audio_channel_0 = NULL;
  GtkWidget *radiobutton_audio_channel_1 = NULL;
  GtkWidget *radiobutton_audio_channel_2 = NULL;
  GtkWidget *radiobutton_audio_channel_3 = NULL;
  GtkWidget *radiobutton_audio_channel_4 = NULL;
  GtkWidget *radiobutton_audio_channel_5 = NULL;
  GtkWidget *radiobutton_audio_channel_6 = NULL;
  GtkWidget *radiobutton_audio_channel_7 = NULL;
  GtkWidget *combo_subpicture;
  GtkWidget *label6;
  GList *combo_subpicture_items = NULL;
  gint i;
  GtkWidget *combo_entry9;

  /* Destroy previous gui */
  gtk_widget_destroy(vbox9b);

  /* Build Audio and Subpicture gui */
  vbox9b = gtk_vbox_new (TRUE, 0);
  gtk_widget_ref (vbox9b);
  gtk_object_set_data_full (GTK_OBJECT (window1), "vbox9b", vbox9b,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox9b);
  gtk_container_add (GTK_CONTAINER (frame1), vbox9b);
  gtk_container_set_border_width (GTK_CONTAINER (vbox9b), 3);

  hbox21 = gtk_hbox_new (TRUE, 0);
  gtk_widget_ref (hbox21);
  gtk_object_set_data_full (GTK_OBJECT (window1), "hbox21", hbox21,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox21);
  gtk_box_pack_start (GTK_BOX (vbox9b), hbox21, TRUE, TRUE, 0);

  label_ripdvd_select_audio_channel = gtk_label_new (_(" Audio channel  "));
  gtk_widget_ref (label_ripdvd_select_audio_channel);
  gtk_object_set_data_full (GTK_OBJECT (window1), "label_ripdvd_select_audio_channel", label_ripdvd_select_audio_channel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_ripdvd_select_audio_channel);
  gtk_box_pack_start (GTK_BOX (hbox21), label_ripdvd_select_audio_channel, FALSE, FALSE, 0);

  vbox9 = gtk_vbox_new (TRUE, 0);
  gtk_widget_ref (vbox9);
  gtk_object_set_data_full (GTK_OBJECT (window1), "vbox9", vbox9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox9);
  gtk_box_pack_start (GTK_BOX (hbox21), vbox9, TRUE, TRUE, 0);
  /* Audio 0 */
  if (Config.audio_channels_in_dvd[Config.VT_belongs_to_VTS[Config.CS_belongs_to_VT[first_selected_titel()]]]>0) {
      radiobutton_audio_channel_0 = gtk_radio_button_new_with_label (audio_channels_group, Config.audio_channel_names[Config.VT_belongs_to_VTS[Config.CS_belongs_to_VT[first_selected_titel()]]][0]->str);
      audio_channels_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_audio_channel_0));
      gtk_widget_ref (radiobutton_audio_channel_0);
      gtk_object_set_data_full (GTK_OBJECT (window1), "radiobutton_audio_channel_0", radiobutton_audio_channel_0,
                                (GtkDestroyNotify) gtk_widget_unref);
      gtk_widget_show (radiobutton_audio_channel_0);
      gtk_box_pack_start (GTK_BOX (vbox9), radiobutton_audio_channel_0, FALSE, FALSE, 0);
      /* Audio type unsupported */
      if (Config.audio_channel_types[Config.VT_belongs_to_VTS[Config.CS_belongs_to_VT[first_selected_titel()]]][0] == 6) {
          gtk_widget_set_sensitive(radiobutton_audio_channel_0,FALSE);
          g_log(DRIP_CB_LD,G_LOG_LEVEL_MESSAGE,"Audio channel 0 is of type DTS, unsupported");
      }
  }

  /* Audio 1 */
  if (Config.audio_channels_in_dvd[Config.VT_belongs_to_VTS[Config.CS_belongs_to_VT[first_selected_titel()]]]>1) {
      radiobutton_audio_channel_1 = gtk_radio_button_new_with_label (audio_channels_group,  Config.audio_channel_names[Config.VT_belongs_to_VTS[Config.CS_belongs_to_VT[first_selected_titel()]]][1]->str);
      audio_channels_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_audio_channel_1));
      gtk_widget_ref (radiobutton_audio_channel_1);
      gtk_object_set_data_full (GTK_OBJECT (window1), "radiobutton_audio_channel_1", radiobutton_audio_channel_1,
                                (GtkDestroyNotify) gtk_widget_unref);
      gtk_widget_show (radiobutton_audio_channel_1);
      gtk_box_pack_start (GTK_BOX (vbox9), radiobutton_audio_channel_1, FALSE, FALSE, 0);
      /* Audio type unsupported */
      if (Config.audio_channel_types[Config.VT_belongs_to_VTS[Config.CS_belongs_to_VT[first_selected_titel()]]][1] == 6) {
          gtk_widget_set_sensitive(radiobutton_audio_channel_1,FALSE);
          g_log(DRIP_CB_LD,G_LOG_LEVEL_MESSAGE,"Audio channel 1 is of type DTS, unsupported");
      }
  }

  /* Audio 2 */
  if (Config.audio_channels_in_dvd[Config.VT_belongs_to_VTS[Config.CS_belongs_to_VT[first_selected_titel()]]]>2) {
      radiobutton_audio_channel_2 = gtk_radio_button_new_with_label (audio_channels_group,  Config.audio_channel_names[Config.VT_belongs_to_VTS[Config.CS_belongs_to_VT[first_selected_titel()]]][2]->str);
      audio_channels_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_audio_channel_2));
      gtk_widget_ref (radiobutton_audio_channel_2);
      gtk_object_set_data_full (GTK_OBJECT (window1), "radiobutton_audio_channel_2", radiobutton_audio_channel_2,
                                (GtkDestroyNotify) gtk_widget_unref);
      gtk_widget_show (radiobutton_audio_channel_2);
      gtk_box_pack_start (GTK_BOX (vbox9), radiobutton_audio_channel_2, FALSE, FALSE, 0);
      /* Audio type unsupported */
      if (Config.audio_channel_types[Config.VT_belongs_to_VTS[Config.CS_belongs_to_VT[first_selected_titel()]]][2] == 6) {
          gtk_widget_set_sensitive(radiobutton_audio_channel_2,FALSE);
          g_log(DRIP_CB_LD,G_LOG_LEVEL_MESSAGE,"Audio channel 2 is of type DTS, unsupported");
      }

  }

  /* Audio 3 */
  if (Config.audio_channels_in_dvd[Config.VT_belongs_to_VTS[Config.CS_belongs_to_VT[first_selected_titel()]]]>3) {
      radiobutton_audio_channel_3 = gtk_radio_button_new_with_label (audio_channels_group, Config.audio_channel_names[Config.VT_belongs_to_VTS[Config.CS_belongs_to_VT[first_selected_titel()]]][3]->str);
      audio_channels_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_audio_channel_3));
      gtk_widget_ref (radiobutton_audio_channel_3);
      gtk_object_set_data_full (GTK_OBJECT (window1), "radiobutton_audio_channel_3", radiobutton_audio_channel_3,
                                (GtkDestroyNotify) gtk_widget_unref);
      gtk_widget_show (radiobutton_audio_channel_3);
      gtk_box_pack_start (GTK_BOX (vbox9), radiobutton_audio_channel_3, FALSE, FALSE, 0);
      /* Audio type unsupported */
      if (Config.audio_channel_types[Config.VT_belongs_to_VTS[Config.CS_belongs_to_VT[first_selected_titel()]]][3] == 6) {
          gtk_widget_set_sensitive(radiobutton_audio_channel_3,FALSE);
          g_log(DRIP_CB_LD,G_LOG_LEVEL_MESSAGE,"Audio channel 3 is of type DTS, unsupported");
      }

  }

  /* Audio 4 */
  if (Config.audio_channels_in_dvd[Config.VT_belongs_to_VTS[Config.CS_belongs_to_VT[first_selected_titel()]]]>4) {
      radiobutton_audio_channel_4 = gtk_radio_button_new_with_label (audio_channels_group, Config.audio_channel_names[Config.VT_belongs_to_VTS[Config.CS_belongs_to_VT[first_selected_titel()]]][4]->str);
      audio_channels_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_audio_channel_4));
      gtk_widget_ref (radiobutton_audio_channel_4);
      gtk_object_set_data_full (GTK_OBJECT (window1), "radiobutton_audio_channel_4", radiobutton_audio_channel_4,
                                (GtkDestroyNotify) gtk_widget_unref);
      gtk_widget_show (radiobutton_audio_channel_4);
      gtk_box_pack_start (GTK_BOX (vbox9), radiobutton_audio_channel_4, FALSE, FALSE, 0);
      /* Audio type unsupported */
      if (Config.audio_channel_types[Config.VT_belongs_to_VTS[Config.CS_belongs_to_VT[first_selected_titel()]]][4] == 6) {
          gtk_widget_set_sensitive(radiobutton_audio_channel_4,FALSE);
          g_log(DRIP_CB_LD,G_LOG_LEVEL_MESSAGE,"Audio channel 4 is of type DTS, unsupported");
      }

  }

  /* Audio 5 */
  if (Config.audio_channels_in_dvd[Config.VT_belongs_to_VTS[Config.CS_belongs_to_VT[first_selected_titel()]]]>5) {
      radiobutton_audio_channel_5 = gtk_radio_button_new_with_label (audio_channels_group, Config.audio_channel_names[Config.VT_belongs_to_VTS[Config.CS_belongs_to_VT[first_selected_titel()]]][5]->str);
      audio_channels_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_audio_channel_5));
      gtk_widget_ref (radiobutton_audio_channel_5);
      gtk_object_set_data_full (GTK_OBJECT (window1), "radiobutton_audio_channel_5", radiobutton_audio_channel_5,
                                (GtkDestroyNotify) gtk_widget_unref);
      gtk_widget_show (radiobutton_audio_channel_5);
      gtk_box_pack_start (GTK_BOX (vbox9), radiobutton_audio_channel_5, FALSE, FALSE, 0);
      /* Audio type unsupported */
      if (Config.audio_channel_types[Config.VT_belongs_to_VTS[Config.CS_belongs_to_VT[first_selected_titel()]]][5] == 6) {
          gtk_widget_set_sensitive(radiobutton_audio_channel_5,FALSE);
          g_log(DRIP_CB_LD,G_LOG_LEVEL_MESSAGE,"Audio channel 5 is of type DTS, unsupported");
      }

  }

  /* Audio 6 */
  if (Config.audio_channels_in_dvd[Config.VT_belongs_to_VTS[Config.CS_belongs_to_VT[first_selected_titel()]]]>6) {
      radiobutton_audio_channel_6 = gtk_radio_button_new_with_label (audio_channels_group, Config.audio_channel_names[Config.VT_belongs_to_VTS[Config.CS_belongs_to_VT[first_selected_titel()]]][6]->str);
      audio_channels_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_audio_channel_6));
      gtk_widget_ref (radiobutton_audio_channel_6);
      gtk_object_set_data_full (GTK_OBJECT (window1), "radiobutton_audio_channel_6", radiobutton_audio_channel_6,
                                (GtkDestroyNotify) gtk_widget_unref);
      gtk_widget_show (radiobutton_audio_channel_6);
      gtk_box_pack_start (GTK_BOX (vbox9), radiobutton_audio_channel_6, FALSE, FALSE, 0);
      /* Audio type unsupported */
      if (Config.audio_channel_types[Config.VT_belongs_to_VTS[Config.CS_belongs_to_VT[first_selected_titel()]]][6] == 6) {
          gtk_widget_set_sensitive(radiobutton_audio_channel_6,FALSE);
          g_log(DRIP_CB_LD,G_LOG_LEVEL_MESSAGE,"Audio channel 6 is of type DTS, unsupported");
      }
  }

  /* Audio 7 */
  if (Config.audio_channels_in_dvd[Config.VT_belongs_to_VTS[Config.CS_belongs_to_VT[first_selected_titel()]]]>7) {
      radiobutton_audio_channel_7 = gtk_radio_button_new_with_label (audio_channels_group, Config.audio_channel_names[Config.VT_belongs_to_VTS[Config.CS_belongs_to_VT[first_selected_titel()]]][7]->str);
      audio_channels_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_audio_channel_7));
      gtk_widget_ref (radiobutton_audio_channel_7);
      gtk_object_set_data_full (GTK_OBJECT (window1), "radiobutton_audio_channel_7", radiobutton_audio_channel_7,
                                (GtkDestroyNotify) gtk_widget_unref);
      gtk_widget_show (radiobutton_audio_channel_7);
      gtk_box_pack_start (GTK_BOX (vbox9), radiobutton_audio_channel_7, FALSE, FALSE, 0);
      /* Audio type unsupported */
      if (Config.audio_channel_types[Config.VT_belongs_to_VTS[Config.CS_belongs_to_VT[first_selected_titel()]]][7] == 6) {
          gtk_widget_set_sensitive(radiobutton_audio_channel_7,FALSE);
          g_log(DRIP_CB_LD,G_LOG_LEVEL_MESSAGE,"Audio channel 7 is of type DTS, unsupported");
      }
  }

  /* Subpictures */
  hbox22 = gtk_hbox_new (TRUE, 0);
  gtk_widget_ref (hbox22);
  gtk_object_set_data_full (GTK_OBJECT (window1), "hbox22", hbox22,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox22);
  gtk_box_pack_start (GTK_BOX (vbox9b), hbox22, TRUE, TRUE, 5);

  label6 = gtk_label_new (_(" Subpicture   "));
  gtk_widget_ref (label6);
  gtk_object_set_data_full (GTK_OBJECT (window1), "label6", label6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label6);
  gtk_box_pack_start (GTK_BOX (hbox22), label6, FALSE, FALSE, 0);

  combo_subpicture = gtk_combo_new ();
  gtk_widget_ref (combo_subpicture);
  gtk_object_set_data_full (GTK_OBJECT (window1), "combo_subpicture", combo_subpicture,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (combo_subpicture);
  gtk_box_pack_start (GTK_BOX (hbox22), combo_subpicture, TRUE, TRUE, 0);
  combo_subpicture_items = g_list_append (combo_subpicture_items, (gpointer)"None");
  for (i=0;i<Config.subpictures_in_dvd[Config.VT_belongs_to_VTS[Config.CS_belongs_to_VT[first_selected_titel()]]];i++) {
      combo_subpicture_items = g_list_append (combo_subpicture_items, (gpointer)Config.subpicture_names[Config.VT_belongs_to_VTS[Config.CS_belongs_to_VT[first_selected_titel()]]][i]->str);
  }
  gtk_combo_set_popdown_strings (GTK_COMBO (combo_subpicture), combo_subpicture_items);
  g_list_free (combo_subpicture_items);

  combo_entry9 = GTK_COMBO (combo_subpicture)->entry;
  gtk_widget_ref (combo_entry9);
  gtk_object_set_data_full (GTK_OBJECT (window1), "combo_entry9", combo_entry9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (combo_entry9);
  gtk_entry_set_text (GTK_ENTRY (combo_entry9), "None");

  /* Callbacks */
  if (Config.audio_channels_in_dvd[Config.VT_belongs_to_VTS[Config.CS_belongs_to_VT[first_selected_titel()]]]>0) {
      gtk_signal_connect (GTK_OBJECT (radiobutton_audio_channel_0), "toggled",
                          GTK_SIGNAL_FUNC (on_radiobutton_audio_channel_0_toggled),
                          radiobutton_audio_channel_0);
  }
  if (Config.audio_channels_in_dvd[Config.VT_belongs_to_VTS[Config.CS_belongs_to_VT[first_selected_titel()]]]>1) {
      gtk_signal_connect (GTK_OBJECT (radiobutton_audio_channel_1), "toggled",
                          GTK_SIGNAL_FUNC (on_radiobutton_audio_channel_1_toggled),
                          radiobutton_audio_channel_1);
  }
  if (Config.audio_channels_in_dvd[Config.VT_belongs_to_VTS[Config.CS_belongs_to_VT[first_selected_titel()]]]>2) {
      gtk_signal_connect (GTK_OBJECT (radiobutton_audio_channel_2), "toggled",
                          GTK_SIGNAL_FUNC (on_radiobutton_audio_channel_2_toggled),
                          radiobutton_audio_channel_2);
  }
  if (Config.audio_channels_in_dvd[Config.VT_belongs_to_VTS[Config.CS_belongs_to_VT[first_selected_titel()]]]>3) {
      gtk_signal_connect (GTK_OBJECT (radiobutton_audio_channel_3), "toggled",
                          GTK_SIGNAL_FUNC (on_radiobutton_audio_channel_3_toggled),
                          radiobutton_audio_channel_3);
  }
  if (Config.audio_channels_in_dvd[Config.VT_belongs_to_VTS[Config.CS_belongs_to_VT[first_selected_titel()]]]>4) {
      gtk_signal_connect (GTK_OBJECT (radiobutton_audio_channel_4), "toggled",
                          GTK_SIGNAL_FUNC (on_radiobutton_audio_channel_4_toggled),
                          radiobutton_audio_channel_4);
  }
  if (Config.audio_channels_in_dvd[Config.VT_belongs_to_VTS[Config.CS_belongs_to_VT[first_selected_titel()]]]>5) {
      gtk_signal_connect (GTK_OBJECT (radiobutton_audio_channel_5), "toggled",
                          GTK_SIGNAL_FUNC (on_radiobutton_audio_channel_5_toggled),
                          radiobutton_audio_channel_5);
  }
  if (Config.audio_channels_in_dvd[Config.VT_belongs_to_VTS[Config.CS_belongs_to_VT[first_selected_titel()]]]>6) {
      gtk_signal_connect (GTK_OBJECT (radiobutton_audio_channel_6), "toggled",
                          GTK_SIGNAL_FUNC (on_radiobutton_audio_channel_6_toggled),
                          radiobutton_audio_channel_6);
  }
  if (Config.audio_channels_in_dvd[Config.VT_belongs_to_VTS[Config.CS_belongs_to_VT[first_selected_titel()]]]>7) {
      gtk_signal_connect (GTK_OBJECT (radiobutton_audio_channel_7), "toggled",
                          GTK_SIGNAL_FUNC (on_radiobutton_audio_channel_7_toggled),
                          radiobutton_audio_channel_7);
  }
  gtk_signal_connect (GTK_OBJECT (combo_entry9), "changed",
                      GTK_SIGNAL_FUNC (on_combo_entry9_changed),
                      combo_entry9);
    return;
}


void on_save_preferences_activate(GtkMenuItem *menuitem, gpointer user_data) {
    save_config(FALSE);
    gnome_appbar_set_status(GNOME_APPBAR(appbar1),"Done saving.");
    return;
}

void on_ripdvd_activate(GtkMenuItem *menuitem, gpointer user_data) {
    on_button_main_rip_clicked((GtkButton*)menuitem,user_data);
    return;
}

void on_button_calculate_bitrate_clicked(GtkButton *button, gpointer user_data) {
    GtkWidget *calc_window;

    calc_window = create_calculate_bitrate();
    gtk_widget_show(calc_window);
    return;
}

void on_rescan_for_dvd_activate(GtkMenuItem *menuitem, gpointer user_data) {
    on_button_main_rescan_clicked(NULL,NULL);
    return;
}


void on_exit1_activate(GtkMenuItem *menuitem, gpointer user_data) {
    terminate(FALSE,FALSE);
    return;
}

void on_preferences1_activate(GtkMenuItem *menuitem, gpointer user_data) {
    /* show properties interface */
    if (propertybox1 == NULL) {
        propertybox1 = create_propertybox1 ();
        gtk_widget_show (propertybox1);
    }
    return;
}


void on_about1_activate(GtkMenuItem *menuitem,gpointer user_data) {
    GtkWidget* aboutbox;
    aboutbox = create_about_drip();
    gtk_widget_show(aboutbox);
    return;
}


/* Remove dialogs and stop encoding process */
void on_drip_druid_cancel(GnomeDruid *gnomedruid,gpointer user_data) {
    encoder_stop(FALSE);
    converting = FALSE;
    pthread_cancel(ripthread);
    gtk_widget_destroy(audio_subpicture_dialog);
    audio_subpicture_dialog = NULL;
    encoding_time = FALSE;
    return;
}


/* Keep track of page location and update internal status accordingly */
gboolean on_drip_druid_next(GnomeDruidPage *druidpage,gpointer arg1,gpointer user_data) {
    GString *command = g_string_new("");
    GString *temp = g_string_new("");
    gint i;
    gint result = 0;
    struct stat st;
    gint err;
    GString *text = g_string_new("");
    GtkWidget *vbox23;
    GtkWidget *scrolledwindow6;
    GtkWidget *viewport1;
    /* list widgets */
    GtkWidget *clist1;
    GtkWidget *label_select_titel;
    GtkWidget *label_select_playback;
    GtkWidget *label_select_frames;
    GtkWidget *label_select_aspect;
    GtkWidget *label_select_FPS;
    GString *select_titel = g_string_new("");
    GString *select_playback = g_string_new("");
    GString *select_frames = g_string_new("");
    GString *select_aspect = g_string_new("");
    GString *select_FPS = g_string_new("");
    gchar *row[5];

    /* Keep track of page location and update internal status accordingly */

    /* Location of input content */
    if (Config.useDVDdevice==FALSE) {
        g_string_sprintf(temp,"%s",Config.DVDsource->str);
    } else {
        g_string_sprintf(temp,"%s",Config.DVDdevice->str);
    }
    g_log(DRIP_CB_LD,G_LOG_LEVEL_DEBUG,"Opening DVD content at %s",temp->str);

    /* Does source content location exsists? */
    if (stat(temp->str, &st) != 0) {
        g_log(DRIP_CB_LD,G_LOG_LEVEL_WARNING,"Content not found (%s %s)",strerror(errno),temp->str);
        /* Clean & exit */
        converting = FALSE;
        gnome_appbar_set_status(GNOME_APPBAR(appbar1),"Ready");
        g_string_free(command,TRUE);
        g_string_free(temp,TRUE);
        g_string_free(cached_files,TRUE);
        pthread_cancel(ripthread_id);
        return FALSE;
    }

    /* Opening cached files or DVD contents? */
    g_string_sprintf(command,"ls -lsa %s | grep DVDTITLE.tbl | awk '{printf($10)}'",temp->str);
    text = drip_system(command->str,&result,FALSE,FALSE);
    if (strstr(text->str,"DVDTITLE")!=NULL) {
        Config.DVDhandle = NULL;
        Config.conversion_mode = DVDTITLE_DRIPCACHE;
        load_dvd_title_info(-1,FALSE);
        g_log(DRIP_CB_LD,G_LOG_LEVEL_DEBUG,"Opened Drip cache from %s",temp->str);
    } else {
        Config.DVDhandle = DVDOpen(temp->str);
        err = errno;
        g_log(DRIP_CB_LD,G_LOG_LEVEL_DEBUG,"After DVDOpen (%s %s)",strerror(err),temp->str);
        /* Check operation */
        switch (err) {
        case 123:/* NO medium found */
                g_log(DRIP_CB_LD,G_LOG_LEVEL_WARNING,"Content not opened (%s %s)",strerror(err),temp->str);
                /* Clean & exit */
                converting = FALSE;
                gnome_appbar_set_status(GNOME_APPBAR(appbar1),"Ready");
                g_string_free(command,TRUE);
                g_string_free(temp,TRUE);
                pthread_cancel(ripthread);
                gtk_widget_destroy(audio_subpicture_dialog);
                audio_subpicture_dialog = NULL;
                return TRUE;
                break;
        default:
                break;
        }
        // TODO: check if location is valid, cq contains content
        if (!detect_DVD_titles(FALSE)) {
            g_log(DRIP_CB_LD,G_LOG_LEVEL_ERROR,"Could not open DVD content");
        }
        selected_files = 1; // we're about to read one stream
        if (Config.useDVDdevice==FALSE) {
            Config.conversion_mode = DVDTITLE_DVDDISK;
        } else {
            Config.conversion_mode = DVDTITLE_DVDIMAGE;
        }
        g_log(DRIP_CB_LD,G_LOG_LEVEL_DEBUG,"Opened DVD content at %s",temp->str);

    }
    if ((Config.conversion_mode == DVDTITLE_DVDDISK) || (Config.conversion_mode == DVDTITLE_DVDIMAGE)) {
        for (i=0;i<Config.DVD_TitleSets;i++) {
            parse_ifo(i+1,FALSE);
        }
    }

    /* Destroy old page */
    gtk_widget_destroy(frame5);

    /* Build Titles Page */
    frame5 = gtk_frame_new (NULL);
    gtk_widget_ref (frame5);
    gtk_object_set_data_full (GTK_OBJECT (window1), "frame5", frame5,
                            (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show (frame5);
    gtk_container_add (GTK_CONTAINER (druid_vbox2), frame5);
    gtk_container_set_border_width (GTK_CONTAINER (frame5), 3);

    vbox23 = gtk_vbox_new (FALSE, 0);
    gtk_widget_ref (vbox23);
    gtk_object_set_data_full (GTK_OBJECT (window1), "vbox23", vbox23,
                            (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show (vbox23);
    gtk_container_add (GTK_CONTAINER (frame5), vbox23);
    gtk_container_set_border_width (GTK_CONTAINER (vbox23), 3);

    scrolledwindow6 = gtk_scrolled_window_new (NULL, NULL);
    gtk_widget_ref (scrolledwindow6);
    gtk_object_set_data_full (GTK_OBJECT (window1), "scrolledwindow6", scrolledwindow6,                            (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show (scrolledwindow6);
    gtk_box_pack_start (GTK_BOX (vbox23), scrolledwindow6, TRUE, TRUE, 0);
    gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow6), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

    viewport1 = gtk_viewport_new (NULL, NULL);
    gtk_widget_ref (viewport1);
    gtk_object_set_data_full (GTK_OBJECT (window1), "viewport1", viewport1,
                              (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show (viewport1);
    gtk_container_add (GTK_CONTAINER (scrolledwindow6), viewport1);

    clist1 = gtk_clist_new (5);
    gtk_widget_ref (clist1);
    gtk_object_set_data_full (GTK_OBJECT (window1), "clist1", clist1,(GtkDestroyNotify) gtk_widget_unref);
    gtk_container_add (GTK_CONTAINER (viewport1), clist1);
    gtk_widget_show (clist1);
    gtk_clist_set_column_width (GTK_CLIST (clist1), 0, 160);
    gtk_clist_set_column_width (GTK_CLIST (clist1), 1, 100);
    gtk_clist_set_column_width (GTK_CLIST (clist1), 2, 150);
    gtk_clist_set_column_width (GTK_CLIST (clist1), 3, 80);
    gtk_clist_set_column_width (GTK_CLIST (clist1), 4, 80);
    gtk_clist_set_column_auto_resize (GTK_CLIST (clist1), 0,TRUE);
    gtk_clist_set_column_auto_resize (GTK_CLIST (clist1), 1,TRUE);
    gtk_clist_set_column_auto_resize (GTK_CLIST (clist1), 2,TRUE);
    gtk_clist_set_column_auto_resize (GTK_CLIST (clist1), 3,TRUE);
    gtk_clist_set_column_auto_resize (GTK_CLIST (clist1), 4,TRUE);
    gtk_clist_set_selection_mode (GTK_CLIST (clist1), GTK_SELECTION_MULTIPLE);
    gtk_clist_column_titles_show (GTK_CLIST (clist1));

    label_select_titel = gtk_label_new (_("DVD Title"));
    gtk_widget_ref (label_select_titel);
    gtk_object_set_data_full (GTK_OBJECT (window1), "label_select_titel", label_select_titel,(GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show (label_select_titel);
    gtk_clist_set_column_widget (GTK_CLIST (clist1), 0, label_select_titel);

    label_select_playback = gtk_label_new (_("Playback"));
    gtk_widget_ref (label_select_playback);
    gtk_object_set_data_full (GTK_OBJECT (window1), "label_select_playback", label_select_playback,(GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show (label_select_playback);
    gtk_clist_set_column_widget (GTK_CLIST (clist1), 1, label_select_playback);

    label_select_frames = gtk_label_new (_("Frames"));
    gtk_widget_ref (label_select_frames);
    gtk_object_set_data_full (GTK_OBJECT (window1), "label_select_frames", label_select_frames,(GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show (label_select_frames);
    gtk_clist_set_column_widget (GTK_CLIST (clist1), 2, label_select_frames);

    label_select_aspect = gtk_label_new (_("Aspect"));
    gtk_widget_ref (label_select_aspect);
    gtk_object_set_data_full (GTK_OBJECT (window1), "label_select_aspect", label_select_aspect,(GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show (label_select_aspect);
    gtk_clist_set_column_widget (GTK_CLIST (clist1), 3, label_select_aspect);

    label_select_FPS = gtk_label_new (_("FPS"));
    gtk_widget_ref (label_select_FPS);
    gtk_object_set_data_full (GTK_OBJECT (window1), "label_select_FPS", label_select_FPS,(GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show (label_select_FPS);
    gtk_clist_set_column_widget (GTK_CLIST (clist1), 4, label_select_FPS);

    /* Attach callback handler */
    gtk_signal_connect (GTK_OBJECT (clist1), "select_row",GTK_SIGNAL_FUNC (on_dvdtitels_select_row),NULL);
    gtk_signal_connect (GTK_OBJECT (clist1), "unselect_row",GTK_SIGNAL_FUNC (on_dvdtitels_unselect_row),NULL);

    /* Fill in columns */
    for (i=0;i<Config.DVD_Total_ChapterSequences;i++) {
        g_string_sprintf(select_titel,"%i",i+1);
        seconds2time((gint)(Config.frames2encode[i]/Config.framerate),select_playback);
        g_string_sprintf(select_frames,"%i",Config.frames2encode[i]);
        g_string_sprintf(select_aspect,"%.3g:1",Config.VTS_Aspects[Config.VT_belongs_to_VTS[Config.CS_belongs_to_VT[i]]]);
        g_string_sprintf(select_FPS,"%g",Config.framerate);

        row[0] = select_titel->str;
        row[1] = select_playback->str;
        row[2] = select_frames->str;
        row[3] = select_aspect->str;
        row[4] = select_FPS->str;
        gtk_clist_append(GTK_CLIST(clist1),row);
        if (Config.CS[i]==TRUE) {
            gtk_clist_select_row(GTK_CLIST(clist1),i,0);
        }
    }

    /* Set next (dummy) page */
    on_combo_entry_DVDtitle_changed(NULL,NULL);

    /* Call divx output naming */
    format_divxname(Config.DIVXfileUser,FALSE);

    /* Clean & Exit */
    g_string_free(temp,TRUE);
    g_string_free(command,TRUE);
    g_string_free(text,TRUE);
    g_string_free(select_titel,TRUE);
    g_string_free(select_playback,TRUE);
    g_string_free(select_frames,TRUE);
    g_string_free(select_aspect,TRUE);
    g_string_free(select_FPS,TRUE);
    return FALSE;
}


void on_drip_druidpagefinish1_finish(GnomeDruidPage *gnomedruidpage, gpointer arg1, gpointer user_data) {
    /* Remove dialog and continue encoding process */
    gtk_widget_destroy(audio_subpicture_dialog);
    audio_subpicture_dialog = NULL;
    return;
}

