#include <gnome.h>
#include <dirent.h>
#include <pthread.h>
#include <dvdread/dvd_reader.h>
#include <dvdread/ifo_types.h>
#include <dvdread/ifo_read.h>
#include <dvdread/nav_read.h>
#include <dvdread/nav_print.h>


/* structs */
typedef struct _drip_system_t {
    gchar *command;
    gint *exec_result;
    gboolean freebuffer;
} drip_system_t;

/* general proto's */
gboolean parse_clut(ifo_handle_t *ifo,gboolean lock);
gint first_selected_titel(void);
void detect_largest_title(void);
gboolean read_dvd_title(void);
gboolean detect_DVD_titles(gboolean lock);
gchar *fulllanguage(uint16_t descr);
gboolean save_config(gboolean lock);
void drip_error(gchar *text);
void drip_info(gchar *text);
GString* drip_system(gchar *command,gint *exec_result,gboolean freebuffer,gboolean lock);
gpointer drip_system_threaded(gpointer data);
void terminate(gboolean hard,gboolean lock);
gchar* mpeg2divx_parameters(void);
gint dirfilter_movie_vob(const struct dirent *entry);
gint dirfilter_all_vob(const struct dirent *entry);
gint dirfilter_all(const struct dirent *entry);
gint dirfilter_divx(const struct dirent *entry);
gint manual_stream_select(gchar *video_location);
gboolean remove_cache(gboolean lock);
gboolean detect_source_filesystem(void);
void save_dvd_title_info(gboolean lock);
gboolean load_dvd_title_info(gint requested_title,gboolean lock);
gchar* detect_source_track_dir(gboolean lock);
gboolean check_for_supermount_fs(void);
gboolean user_can_mount_dvd(void);
gint detect_largest_vob_sequence(gchar *video_location);
gint dirfilter_avi(const struct dirent *entry);
void rename_divx_files(void);
gboolean eject_dvdrom(gchar *track_dir,gchar *dvddevice,gboolean lock);
gpointer make_iso_images(gpointer data);
gchar* readlink_malloc (gchar *filename);
gpointer heat_thread(gpointer data);
gboolean cache_vobs_for_ifo(void);
void cache_track(gchar *dir,gchar *track,gfloat perc,guint nr,gint);
gboolean config_ok(void);
gpointer conversion_thread(gpointer data);
//gboolean parse_clut(ifo_handle_t *ifo);
gboolean parse_ifo(gint dvdtitle,gboolean lock);
gboolean format_divxname(GString *DIVXfile,gboolean lock);
gboolean drip_dvdname_check(GString*);
void seconds2time(gint seconds,GString *time);
gboolean free_space(gchar* mountpoint,glong min_freespace,glong warning_freespace,gboolean _lock);


extern gint selected_files;
extern GString *files[1000];
extern gint cached_files_list;
extern GString *cached_file_list[1000];

extern gboolean paused;
extern gfloat CALCframerate;
extern GString *cached_files;
/* converting thread */
extern pthread_t ripthread;
extern gint ripthread_id;

